//+------------------------------------------------------------------+
//|                                                  HedgeTrader.mq4 |
//|                                  Copyright  2006, Forex-Experts |
//|                                     http://www.forex-experts.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-Experts"
#property link      "http://www.forex-experts.com"

//---- input parameters
extern double    Lot1=2.0;
extern double    Lot2=3.0;
extern string    Sym1="GBPUSD";
extern string    Sym2="EURUSD";
extern string    Operation1="buy";
extern string    Operation2="sell";
extern double    Commission1=4.0;
extern double    Commission2=2.0;
extern double    Profit=5.0;
extern bool 	  SetNewOrders=true;
extern int		  NumTradesForReverse=0;	// Max number of trades after we should reverse for opearations; if 0 - disable it.

extern bool      UseMM=true;
extern double    Delta=500;
extern int 		  MagicNumber=0;


int OP1=-1, OP2=-1;

double Ilo1=0, Ilo2=0;
bool	NewOrders=false;
bool  FirstTime=true;

int	Last1=0, Last2=0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
//init global variables
if (!GlobalVariableCheck("_CanClose"+DoubleToStr(MagicNumber,0))) {
GlobalVariableSet("_CanClose"+DoubleToStr(MagicNumber,0),0);
}      
//if (!GlobalVariableCheck("_CanSet")) {
//GlobalVariableSet("_CanSet",0);
//}      


if (!GlobalVariableCheck("_Trades"+DoubleToStr(MagicNumber,0))) {
GlobalVariableSet("_Trades"+DoubleToStr(MagicNumber,0),0);
}      



if (!GlobalVariableCheck("_Last1"+DoubleToStr(MagicNumber,0))) {
GlobalVariableSet("_Last1"+DoubleToStr(MagicNumber,0),0);
}      
if (!GlobalVariableCheck("_Last2"+DoubleToStr(MagicNumber,0))) {
GlobalVariableSet("_Last2"+DoubleToStr(MagicNumber,0),0);
}      





//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
Ilo1=Lot1; Ilo2=Lot2;
if (UseMM) {
Ilo1=TradeLot(AccountBalance());
Ilo2=Ilo1*(Lot2/Lot1);
}

if (FirstTime==true) {
	NewOrders=true;
	FirstTime=false;
	if (Operation1=="buy" || Operation1=="BUY") OP1=OP_BUY;
	if (Operation2=="buy" || Operation2=="BUY") OP2=OP_BUY; 
	if (Operation1=="sell" || Operation1=="SELL") OP1=OP_SELL; 
	if (Operation2=="sell" || Operation2=="SELL") OP2=OP_SELL; 
	GlobalVariableSet("_Last1"+DoubleToStr(MagicNumber,0),OP1);
	GlobalVariableSet("_Last2"+DoubleToStr(MagicNumber,0),OP2);
	Last1=OP1;
	Last2=OP2;
}

if (CntOrd(OP_BUY,MagicNumber,Sym1)>0) {
	OP1=OP_BUY;
	GlobalVariableSet("_Last1"+DoubleToStr(MagicNumber,0),OP1);
}	

if (CntOrd(OP_SELL,MagicNumber,Sym1)>0) {
	OP1=OP_SELL;
	GlobalVariableSet("_Last1"+DoubleToStr(MagicNumber,0),OP1);
}	

if (CntOrd(OP_BUY,MagicNumber,Sym2)>0) {
	OP2=OP_BUY;
	GlobalVariableSet("_Last2"+DoubleToStr(MagicNumber,0),OP2);
}	

if (CntOrd(OP_SELL,MagicNumber,Sym2)>0) {
	OP2=OP_SELL;
	GlobalVariableSet("_Last2"+DoubleToStr(MagicNumber,0),OP2);
}	





//---- 
double Commissions=0;




if (OP1<0 || OP2<0) {
   Comment("Wrong operation selected, aborted...");
   return;
}

int	_Trades=0;

if (GlobalVariableGet("_CanClose"+DoubleToStr(MagicNumber,0))==1 && CntOrd(GlobalVariableGet("_Last1"+DoubleToStr(MagicNumber,0)),MagicNumber,Sym1)==0 && CntOrd(GlobalVariableGet("_Last2"+DoubleToStr(MagicNumber,0)),MagicNumber,Sym2)==0) {
	_Trades=GlobalVariableGet("_Trades"+DoubleToStr(MagicNumber,0))+1;
	GlobalVariableSet("_Trades"+DoubleToStr(MagicNumber,0),_Trades);
   GlobalVariableSet("_CanClose"+DoubleToStr(MagicNumber,0),0);
}

if (GlobalVariableGet("_CanClose"+DoubleToStr(MagicNumber,0))==0 && CntOrd(GlobalVariableGet("_Last1"+DoubleToStr(MagicNumber,0)),MagicNumber,Sym1)==0 && CntOrd(GlobalVariableGet("_Last2"+DoubleToStr(MagicNumber,0)),MagicNumber,Sym2)==0) {
	if(NumTradesForReverse != 0)
	{
	if (GlobalVariableGet("_Trades"+DoubleToStr(MagicNumber,0))>=NumTradesForReverse) {
		GlobalVariableSet("_Trades"+DoubleToStr(MagicNumber,0),0);			
		if (GlobalVariableGet("_Last1"+DoubleToStr(MagicNumber,0))==OP_BUY) OP1=OP_SELL; else OP1=OP_BUY;
		if (GlobalVariableGet("_Last2"+DoubleToStr(MagicNumber,0))==OP_BUY) OP2=OP_SELL; else OP2=OP_BUY;				
	}
	}
}


if (GlobalVariableGet("_CanClose"+DoubleToStr(MagicNumber,0))==0 && NewOrders==true) {
//Set intitial orders
SetOrders();
}



Comment("NewOrders=",NewOrders," Balance=",AccountBalance(),"\n",Sym1," Lot=",Ilo1," ",Sym2," Lot=",Ilo2,"\nFloating profit=",CalcProfit()," Expected profit=",Profit*Ilo1*10,"\nTrades=",GlobalVariableGet("_Trades"+DoubleToStr(MagicNumber,0)));

if (SetNewOrders==false) NewOrders=false;
if (SetNewOrders==true) NewOrders=true;

//Check for profit
Commissions=Commission1*Ilo1+Commission2*Ilo1;

if ( (CalcProfit()-Commissions) >= (Profit*Ilo1*10) ) {
GlobalVariableSet("_CanClose"+DoubleToStr(MagicNumber,0),1);
}    

CloseAll();


//----
   return(0);
  }
//+------------------------------------------------------------------+


double CalcProfit() {
//Calculating profit for opened positions
int cnt;
double _Profit;
_Profit=0;   

for(cnt=0; cnt<OrdersTotal(); cnt++)
{     
   OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	if ((OrderSymbol()==Sym1 || OrderSymbol()==Sym2) && ((OrderMagicNumber()==MagicNumber) || MagicNumber==0)) {
   _Profit=_Profit+OrderProfit(); 
   }   
}
return(_Profit);
}

void CloseAll() {
int _total=OrdersTotal(); // number of orders  
int _ordertype;// order type   
if (_total==0) {return;}
int _ticket; // ticket number
double _priceClose;// price to close orders;
//Closing all opened positions
if (GlobalVariableGet("_CanClose"+DoubleToStr(MagicNumber,0))==1) {
for(int _i=_total-1;_i>=0;_i--)
      {
      if (OrderSelect(_i,SELECT_BY_POS))
         {
         _ordertype=OrderType();
         _ticket=OrderTicket();
         if (((OrderMagicNumber()==MagicNumber) || MagicNumber==0)) {
         switch(_ordertype)
            {
            case 0:
               // close buy                
               _priceClose=MarketInfo(OrderSymbol(),MODE_BID);
               Print("Close on ",_i," position order with ticket ",_ticket);
               OrderClose(_ticket,OrderLots(),_priceClose,0,Red);
               //break;
            case 1:
               // close sell
               _priceClose=MarketInfo(OrderSymbol(),MODE_ASK);
               Print("Close on ",_i," position order with ticket ",_ticket);
               OrderClose(_ticket,OrderLots(),_priceClose,0,Red);
//               break;
            default:
               // values from  1 to 5, deleting pending orders
               Print("Delete on ",_i," position order with ticket ",_ticket);
               OrderDelete(_ticket);  
//               break;
            }    
         }
         
         
         }
}


}
return;
}



void SetOrders() {
//Setting initial orders
double OpenPrice=0;

if (CntOrd(OP1,MagicNumber,Sym1)==0) {
   if (OP1==OP_BUY) OpenPrice=MarketInfo(Sym1,MODE_ASK);
   if (OP1==OP_SELL) OpenPrice=MarketInfo(Sym1,MODE_BID);
   Last1=OP1;
   GlobalVariableSet("_Last1"+DoubleToStr(MagicNumber,0),OP1);
   OrderSend(Sym1,OP1,Ilo1,OpenPrice,0,0,0,"HedgeTrader",MagicNumber,0,Red);
   //return;
}

if (CntOrd(OP2,MagicNumber,Sym2)==0) {
   if (OP2==OP_BUY) OpenPrice=MarketInfo(Sym2,MODE_ASK);
   if (OP2==OP_SELL) OpenPrice=MarketInfo(Sym2,MODE_BID);
   Last2=OP2;
   GlobalVariableSet("_Last2"+DoubleToStr(MagicNumber,0),OP2);
   OrderSend(Sym2,OP2,Ilo2,OpenPrice,0,0,0,"HedgeTrader",MagicNumber,0,Green);
   //return;
}



}



int CntOrd(int Type, int Magic, string Symb) {
//return number of orders with specific parameters
int _CntOrd;
_CntOrd=0;
for(int i=0;i<OrdersTotal();i++)
{
   OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
  
   if (OrderSymbol()==Symb) {
      if ( OrderType()==Type && ((OrderMagicNumber()==Magic) || Magic==0)) _CntOrd++;
   }
}
return(_CntOrd);
}

double TradeLot(double MyBalance) {
double _Ilo=0;
//AccountEquity()
_Ilo=MathFloor(MyBalance/Delta)/10;
if (_Ilo<0.1) _Ilo=0.1;		
return (_Ilo);

}

